package it.sw.pa.comune.artegna.web.rest;

import static it.sw.pa.comune.artegna.domain.StrutturaAsserts.*;
import static it.sw.pa.comune.artegna.web.rest.TestUtil.createUpdateProxyForBean;
import static org.assertj.core.api.Assertions.assertThat;
import static org.hamcrest.Matchers.hasItem;
import static org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors.csrf;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import com.fasterxml.jackson.databind.ObjectMapper;
import it.sw.pa.comune.artegna.IntegrationTest;
import it.sw.pa.comune.artegna.domain.Struttura;
import it.sw.pa.comune.artegna.repository.StrutturaRepository;
import it.sw.pa.comune.artegna.service.dto.StrutturaDTO;
import it.sw.pa.comune.artegna.service.mapper.StrutturaMapper;
import jakarta.persistence.EntityManager;
import java.time.Instant;
import java.time.temporal.ChronoUnit;
import java.util.Random;
import java.util.concurrent.atomic.AtomicLong;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.transaction.annotation.Transactional;

/**
 * Integration tests for the {@link StrutturaResource} REST controller.
 */
@IntegrationTest
@AutoConfigureMockMvc
@WithMockUser
class StrutturaResourceIT {

    private static final String DEFAULT_NOME = "AAAAAAAAAA";
    private static final String UPDATED_NOME = "BBBBBBBBBB";

    private static final String DEFAULT_DESCRIZIONE = "AAAAAAAAAA";
    private static final String UPDATED_DESCRIZIONE = "BBBBBBBBBB";

    private static final String DEFAULT_INDIRIZZO = "AAAAAAAAAA";
    private static final String UPDATED_INDIRIZZO = "BBBBBBBBBB";

    private static final Integer DEFAULT_CAPIENZA_MAX = 1;
    private static final Integer UPDATED_CAPIENZA_MAX = 2;
    private static final Integer SMALLER_CAPIENZA_MAX = 1 - 1;

    private static final Boolean DEFAULT_ATTIVA = false;
    private static final Boolean UPDATED_ATTIVA = true;

    private static final String DEFAULT_FOTO_URL = "AAAAAAAAAA";
    private static final String UPDATED_FOTO_URL = "BBBBBBBBBB";

    private static final Instant DEFAULT_CREATED_AT = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_CREATED_AT = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final Instant DEFAULT_UPDATED_AT = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_UPDATED_AT = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final String ENTITY_API_URL = "/api/strutturas";
    private static final String ENTITY_API_URL_ID = ENTITY_API_URL + "/{id}";

    private static Random random = new Random();
    private static AtomicLong longCount = new AtomicLong(random.nextInt() + (2L * Integer.MAX_VALUE));

    @Autowired
    private ObjectMapper om;

    @Autowired
    private StrutturaRepository strutturaRepository;

    @Autowired
    private StrutturaMapper strutturaMapper;

    @Autowired
    private EntityManager em;

    @Autowired
    private MockMvc restStrutturaMockMvc;

    private Struttura struttura;

    private Struttura insertedStruttura;

    /**
     * Create an entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Struttura createEntity() {
        return new Struttura()
            .nome(DEFAULT_NOME)
            .descrizione(DEFAULT_DESCRIZIONE)
            .indirizzo(DEFAULT_INDIRIZZO)
            .capienzaMax(DEFAULT_CAPIENZA_MAX)
            .attiva(DEFAULT_ATTIVA)
            .fotoUrl(DEFAULT_FOTO_URL)
            .createdAt(DEFAULT_CREATED_AT)
            .updatedAt(DEFAULT_UPDATED_AT);
    }

    /**
     * Create an updated entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Struttura createUpdatedEntity() {
        return new Struttura()
            .nome(UPDATED_NOME)
            .descrizione(UPDATED_DESCRIZIONE)
            .indirizzo(UPDATED_INDIRIZZO)
            .capienzaMax(UPDATED_CAPIENZA_MAX)
            .attiva(UPDATED_ATTIVA)
            .fotoUrl(UPDATED_FOTO_URL)
            .createdAt(UPDATED_CREATED_AT)
            .updatedAt(UPDATED_UPDATED_AT);
    }

    @BeforeEach
    void initTest() {
        struttura = createEntity();
    }

    @AfterEach
    void cleanup() {
        if (insertedStruttura != null) {
            strutturaRepository.delete(insertedStruttura);
            insertedStruttura = null;
        }
    }

    @Test
    @Transactional
    void createStruttura() throws Exception {
        long databaseSizeBeforeCreate = getRepositoryCount();
        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);
        var returnedStrutturaDTO = om.readValue(
            restStrutturaMockMvc
                .perform(
                    post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(strutturaDTO))
                )
                .andExpect(status().isCreated())
                .andReturn()
                .getResponse()
                .getContentAsString(),
            StrutturaDTO.class
        );

        // Validate the Struttura in the database
        assertIncrementedRepositoryCount(databaseSizeBeforeCreate);
        var returnedStruttura = strutturaMapper.toEntity(returnedStrutturaDTO);
        assertStrutturaUpdatableFieldsEquals(returnedStruttura, getPersistedStruttura(returnedStruttura));

        insertedStruttura = returnedStruttura;
    }

    @Test
    @Transactional
    void createStrutturaWithExistingId() throws Exception {
        // Create the Struttura with an existing ID
        struttura.setId(1L);
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        long databaseSizeBeforeCreate = getRepositoryCount();

        // An entity with an existing ID cannot be created, so this API call must fail
        restStrutturaMockMvc
            .perform(post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(strutturaDTO)))
            .andExpect(status().isBadRequest());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeCreate);
    }

    @Test
    @Transactional
    void getAllStrutturas() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc"))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(struttura.getId().intValue())))
            .andExpect(jsonPath("$.[*].nome").value(hasItem(DEFAULT_NOME)))
            .andExpect(jsonPath("$.[*].descrizione").value(hasItem(DEFAULT_DESCRIZIONE)))
            .andExpect(jsonPath("$.[*].indirizzo").value(hasItem(DEFAULT_INDIRIZZO)))
            .andExpect(jsonPath("$.[*].capienzaMax").value(hasItem(DEFAULT_CAPIENZA_MAX)))
            .andExpect(jsonPath("$.[*].attiva").value(hasItem(DEFAULT_ATTIVA)))
            .andExpect(jsonPath("$.[*].fotoUrl").value(hasItem(DEFAULT_FOTO_URL)))
            .andExpect(jsonPath("$.[*].createdAt").value(hasItem(DEFAULT_CREATED_AT.toString())))
            .andExpect(jsonPath("$.[*].updatedAt").value(hasItem(DEFAULT_UPDATED_AT.toString())));
    }

    @Test
    @Transactional
    void getStruttura() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get the struttura
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL_ID, struttura.getId()))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.id").value(struttura.getId().intValue()))
            .andExpect(jsonPath("$.nome").value(DEFAULT_NOME))
            .andExpect(jsonPath("$.descrizione").value(DEFAULT_DESCRIZIONE))
            .andExpect(jsonPath("$.indirizzo").value(DEFAULT_INDIRIZZO))
            .andExpect(jsonPath("$.capienzaMax").value(DEFAULT_CAPIENZA_MAX))
            .andExpect(jsonPath("$.attiva").value(DEFAULT_ATTIVA))
            .andExpect(jsonPath("$.fotoUrl").value(DEFAULT_FOTO_URL))
            .andExpect(jsonPath("$.createdAt").value(DEFAULT_CREATED_AT.toString()))
            .andExpect(jsonPath("$.updatedAt").value(DEFAULT_UPDATED_AT.toString()));
    }

    @Test
    @Transactional
    void getStrutturasByIdFiltering() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        Long id = struttura.getId();

        defaultStrutturaFiltering("id.equals=" + id, "id.notEquals=" + id);

        defaultStrutturaFiltering("id.greaterThanOrEqual=" + id, "id.greaterThan=" + id);

        defaultStrutturaFiltering("id.lessThanOrEqual=" + id, "id.lessThan=" + id);
    }

    @Test
    @Transactional
    void getAllStrutturasByNomeIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where nome equals to
        defaultStrutturaFiltering("nome.equals=" + DEFAULT_NOME, "nome.equals=" + UPDATED_NOME);
    }

    @Test
    @Transactional
    void getAllStrutturasByNomeIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where nome in
        defaultStrutturaFiltering("nome.in=" + DEFAULT_NOME + "," + UPDATED_NOME, "nome.in=" + UPDATED_NOME);
    }

    @Test
    @Transactional
    void getAllStrutturasByNomeIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where nome is not null
        defaultStrutturaFiltering("nome.specified=true", "nome.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByNomeContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where nome contains
        defaultStrutturaFiltering("nome.contains=" + DEFAULT_NOME, "nome.contains=" + UPDATED_NOME);
    }

    @Test
    @Transactional
    void getAllStrutturasByNomeNotContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where nome does not contain
        defaultStrutturaFiltering("nome.doesNotContain=" + UPDATED_NOME, "nome.doesNotContain=" + DEFAULT_NOME);
    }

    @Test
    @Transactional
    void getAllStrutturasByDescrizioneIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where descrizione equals to
        defaultStrutturaFiltering("descrizione.equals=" + DEFAULT_DESCRIZIONE, "descrizione.equals=" + UPDATED_DESCRIZIONE);
    }

    @Test
    @Transactional
    void getAllStrutturasByDescrizioneIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where descrizione in
        defaultStrutturaFiltering(
            "descrizione.in=" + DEFAULT_DESCRIZIONE + "," + UPDATED_DESCRIZIONE,
            "descrizione.in=" + UPDATED_DESCRIZIONE
        );
    }

    @Test
    @Transactional
    void getAllStrutturasByDescrizioneIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where descrizione is not null
        defaultStrutturaFiltering("descrizione.specified=true", "descrizione.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByDescrizioneContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where descrizione contains
        defaultStrutturaFiltering("descrizione.contains=" + DEFAULT_DESCRIZIONE, "descrizione.contains=" + UPDATED_DESCRIZIONE);
    }

    @Test
    @Transactional
    void getAllStrutturasByDescrizioneNotContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where descrizione does not contain
        defaultStrutturaFiltering("descrizione.doesNotContain=" + UPDATED_DESCRIZIONE, "descrizione.doesNotContain=" + DEFAULT_DESCRIZIONE);
    }

    @Test
    @Transactional
    void getAllStrutturasByIndirizzoIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where indirizzo equals to
        defaultStrutturaFiltering("indirizzo.equals=" + DEFAULT_INDIRIZZO, "indirizzo.equals=" + UPDATED_INDIRIZZO);
    }

    @Test
    @Transactional
    void getAllStrutturasByIndirizzoIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where indirizzo in
        defaultStrutturaFiltering("indirizzo.in=" + DEFAULT_INDIRIZZO + "," + UPDATED_INDIRIZZO, "indirizzo.in=" + UPDATED_INDIRIZZO);
    }

    @Test
    @Transactional
    void getAllStrutturasByIndirizzoIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where indirizzo is not null
        defaultStrutturaFiltering("indirizzo.specified=true", "indirizzo.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByIndirizzoContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where indirizzo contains
        defaultStrutturaFiltering("indirizzo.contains=" + DEFAULT_INDIRIZZO, "indirizzo.contains=" + UPDATED_INDIRIZZO);
    }

    @Test
    @Transactional
    void getAllStrutturasByIndirizzoNotContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where indirizzo does not contain
        defaultStrutturaFiltering("indirizzo.doesNotContain=" + UPDATED_INDIRIZZO, "indirizzo.doesNotContain=" + DEFAULT_INDIRIZZO);
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax equals to
        defaultStrutturaFiltering("capienzaMax.equals=" + DEFAULT_CAPIENZA_MAX, "capienzaMax.equals=" + UPDATED_CAPIENZA_MAX);
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax in
        defaultStrutturaFiltering(
            "capienzaMax.in=" + DEFAULT_CAPIENZA_MAX + "," + UPDATED_CAPIENZA_MAX,
            "capienzaMax.in=" + UPDATED_CAPIENZA_MAX
        );
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax is not null
        defaultStrutturaFiltering("capienzaMax.specified=true", "capienzaMax.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsGreaterThanOrEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax is greater than or equal to
        defaultStrutturaFiltering(
            "capienzaMax.greaterThanOrEqual=" + DEFAULT_CAPIENZA_MAX,
            "capienzaMax.greaterThanOrEqual=" + UPDATED_CAPIENZA_MAX
        );
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsLessThanOrEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax is less than or equal to
        defaultStrutturaFiltering(
            "capienzaMax.lessThanOrEqual=" + DEFAULT_CAPIENZA_MAX,
            "capienzaMax.lessThanOrEqual=" + SMALLER_CAPIENZA_MAX
        );
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsLessThanSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax is less than
        defaultStrutturaFiltering("capienzaMax.lessThan=" + UPDATED_CAPIENZA_MAX, "capienzaMax.lessThan=" + DEFAULT_CAPIENZA_MAX);
    }

    @Test
    @Transactional
    void getAllStrutturasByCapienzaMaxIsGreaterThanSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where capienzaMax is greater than
        defaultStrutturaFiltering("capienzaMax.greaterThan=" + SMALLER_CAPIENZA_MAX, "capienzaMax.greaterThan=" + DEFAULT_CAPIENZA_MAX);
    }

    @Test
    @Transactional
    void getAllStrutturasByAttivaIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where attiva equals to
        defaultStrutturaFiltering("attiva.equals=" + DEFAULT_ATTIVA, "attiva.equals=" + UPDATED_ATTIVA);
    }

    @Test
    @Transactional
    void getAllStrutturasByAttivaIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where attiva in
        defaultStrutturaFiltering("attiva.in=" + DEFAULT_ATTIVA + "," + UPDATED_ATTIVA, "attiva.in=" + UPDATED_ATTIVA);
    }

    @Test
    @Transactional
    void getAllStrutturasByAttivaIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where attiva is not null
        defaultStrutturaFiltering("attiva.specified=true", "attiva.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByFotoUrlIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where fotoUrl equals to
        defaultStrutturaFiltering("fotoUrl.equals=" + DEFAULT_FOTO_URL, "fotoUrl.equals=" + UPDATED_FOTO_URL);
    }

    @Test
    @Transactional
    void getAllStrutturasByFotoUrlIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where fotoUrl in
        defaultStrutturaFiltering("fotoUrl.in=" + DEFAULT_FOTO_URL + "," + UPDATED_FOTO_URL, "fotoUrl.in=" + UPDATED_FOTO_URL);
    }

    @Test
    @Transactional
    void getAllStrutturasByFotoUrlIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where fotoUrl is not null
        defaultStrutturaFiltering("fotoUrl.specified=true", "fotoUrl.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByFotoUrlContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where fotoUrl contains
        defaultStrutturaFiltering("fotoUrl.contains=" + DEFAULT_FOTO_URL, "fotoUrl.contains=" + UPDATED_FOTO_URL);
    }

    @Test
    @Transactional
    void getAllStrutturasByFotoUrlNotContainsSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where fotoUrl does not contain
        defaultStrutturaFiltering("fotoUrl.doesNotContain=" + UPDATED_FOTO_URL, "fotoUrl.doesNotContain=" + DEFAULT_FOTO_URL);
    }

    @Test
    @Transactional
    void getAllStrutturasByCreatedAtIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where createdAt equals to
        defaultStrutturaFiltering("createdAt.equals=" + DEFAULT_CREATED_AT, "createdAt.equals=" + UPDATED_CREATED_AT);
    }

    @Test
    @Transactional
    void getAllStrutturasByCreatedAtIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where createdAt in
        defaultStrutturaFiltering("createdAt.in=" + DEFAULT_CREATED_AT + "," + UPDATED_CREATED_AT, "createdAt.in=" + UPDATED_CREATED_AT);
    }

    @Test
    @Transactional
    void getAllStrutturasByCreatedAtIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where createdAt is not null
        defaultStrutturaFiltering("createdAt.specified=true", "createdAt.specified=false");
    }

    @Test
    @Transactional
    void getAllStrutturasByUpdatedAtIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where updatedAt equals to
        defaultStrutturaFiltering("updatedAt.equals=" + DEFAULT_UPDATED_AT, "updatedAt.equals=" + UPDATED_UPDATED_AT);
    }

    @Test
    @Transactional
    void getAllStrutturasByUpdatedAtIsInShouldWork() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where updatedAt in
        defaultStrutturaFiltering("updatedAt.in=" + DEFAULT_UPDATED_AT + "," + UPDATED_UPDATED_AT, "updatedAt.in=" + UPDATED_UPDATED_AT);
    }

    @Test
    @Transactional
    void getAllStrutturasByUpdatedAtIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        // Get all the strutturaList where updatedAt is not null
        defaultStrutturaFiltering("updatedAt.specified=true", "updatedAt.specified=false");
    }

    private void defaultStrutturaFiltering(String shouldBeFound, String shouldNotBeFound) throws Exception {
        defaultStrutturaShouldBeFound(shouldBeFound);
        defaultStrutturaShouldNotBeFound(shouldNotBeFound);
    }

    /**
     * Executes the search, and checks that the default entity is returned.
     */
    private void defaultStrutturaShouldBeFound(String filter) throws Exception {
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(struttura.getId().intValue())))
            .andExpect(jsonPath("$.[*].nome").value(hasItem(DEFAULT_NOME)))
            .andExpect(jsonPath("$.[*].descrizione").value(hasItem(DEFAULT_DESCRIZIONE)))
            .andExpect(jsonPath("$.[*].indirizzo").value(hasItem(DEFAULT_INDIRIZZO)))
            .andExpect(jsonPath("$.[*].capienzaMax").value(hasItem(DEFAULT_CAPIENZA_MAX)))
            .andExpect(jsonPath("$.[*].attiva").value(hasItem(DEFAULT_ATTIVA)))
            .andExpect(jsonPath("$.[*].fotoUrl").value(hasItem(DEFAULT_FOTO_URL)))
            .andExpect(jsonPath("$.[*].createdAt").value(hasItem(DEFAULT_CREATED_AT.toString())))
            .andExpect(jsonPath("$.[*].updatedAt").value(hasItem(DEFAULT_UPDATED_AT.toString())));

        // Check, that the count call also returns 1
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL + "/count?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(content().string("1"));
    }

    /**
     * Executes the search, and checks that the default entity is not returned.
     */
    private void defaultStrutturaShouldNotBeFound(String filter) throws Exception {
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$").isArray())
            .andExpect(jsonPath("$").isEmpty());

        // Check, that the count call also returns 0
        restStrutturaMockMvc
            .perform(get(ENTITY_API_URL + "/count?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(content().string("0"));
    }

    @Test
    @Transactional
    void getNonExistingStruttura() throws Exception {
        // Get the struttura
        restStrutturaMockMvc.perform(get(ENTITY_API_URL_ID, Long.MAX_VALUE)).andExpect(status().isNotFound());
    }

    @Test
    @Transactional
    void putExistingStruttura() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the struttura
        Struttura updatedStruttura = strutturaRepository.findById(struttura.getId()).orElseThrow();
        // Disconnect from session so that the updates on updatedStruttura are not directly saved in db
        em.detach(updatedStruttura);
        updatedStruttura
            .nome(UPDATED_NOME)
            .descrizione(UPDATED_DESCRIZIONE)
            .indirizzo(UPDATED_INDIRIZZO)
            .capienzaMax(UPDATED_CAPIENZA_MAX)
            .attiva(UPDATED_ATTIVA)
            .fotoUrl(UPDATED_FOTO_URL)
            .createdAt(UPDATED_CREATED_AT)
            .updatedAt(UPDATED_UPDATED_AT);
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(updatedStruttura);

        restStrutturaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, strutturaDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isOk());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPersistedStrutturaToMatchAllProperties(updatedStruttura);
    }

    @Test
    @Transactional
    void putNonExistingStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, strutturaDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithIdMismatchStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithMissingIdPathParamStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(put(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(strutturaDTO)))
            .andExpect(status().isMethodNotAllowed());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void partialUpdateStrutturaWithPatch() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the struttura using partial update
        Struttura partialUpdatedStruttura = new Struttura();
        partialUpdatedStruttura.setId(struttura.getId());

        partialUpdatedStruttura.nome(UPDATED_NOME).descrizione(UPDATED_DESCRIZIONE).updatedAt(UPDATED_UPDATED_AT);

        restStrutturaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedStruttura.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedStruttura))
            )
            .andExpect(status().isOk());

        // Validate the Struttura in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertStrutturaUpdatableFieldsEquals(
            createUpdateProxyForBean(partialUpdatedStruttura, struttura),
            getPersistedStruttura(struttura)
        );
    }

    @Test
    @Transactional
    void fullUpdateStrutturaWithPatch() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the struttura using partial update
        Struttura partialUpdatedStruttura = new Struttura();
        partialUpdatedStruttura.setId(struttura.getId());

        partialUpdatedStruttura
            .nome(UPDATED_NOME)
            .descrizione(UPDATED_DESCRIZIONE)
            .indirizzo(UPDATED_INDIRIZZO)
            .capienzaMax(UPDATED_CAPIENZA_MAX)
            .attiva(UPDATED_ATTIVA)
            .fotoUrl(UPDATED_FOTO_URL)
            .createdAt(UPDATED_CREATED_AT)
            .updatedAt(UPDATED_UPDATED_AT);

        restStrutturaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedStruttura.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedStruttura))
            )
            .andExpect(status().isOk());

        // Validate the Struttura in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertStrutturaUpdatableFieldsEquals(partialUpdatedStruttura, getPersistedStruttura(partialUpdatedStruttura));
    }

    @Test
    @Transactional
    void patchNonExistingStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, strutturaDTO.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithIdMismatchStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithMissingIdPathParamStruttura() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        struttura.setId(longCount.incrementAndGet());

        // Create the Struttura
        StrutturaDTO strutturaDTO = strutturaMapper.toDto(struttura);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restStrutturaMockMvc
            .perform(
                patch(ENTITY_API_URL).with(csrf()).contentType("application/merge-patch+json").content(om.writeValueAsBytes(strutturaDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Struttura in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void deleteStruttura() throws Exception {
        // Initialize the database
        insertedStruttura = strutturaRepository.saveAndFlush(struttura);

        long databaseSizeBeforeDelete = getRepositoryCount();

        // Delete the struttura
        restStrutturaMockMvc
            .perform(delete(ENTITY_API_URL_ID, struttura.getId()).with(csrf()).accept(MediaType.APPLICATION_JSON))
            .andExpect(status().isNoContent());

        // Validate the database contains one less item
        assertDecrementedRepositoryCount(databaseSizeBeforeDelete);
    }

    protected long getRepositoryCount() {
        return strutturaRepository.count();
    }

    protected void assertIncrementedRepositoryCount(long countBefore) {
        assertThat(countBefore + 1).isEqualTo(getRepositoryCount());
    }

    protected void assertDecrementedRepositoryCount(long countBefore) {
        assertThat(countBefore - 1).isEqualTo(getRepositoryCount());
    }

    protected void assertSameRepositoryCount(long countBefore) {
        assertThat(countBefore).isEqualTo(getRepositoryCount());
    }

    protected Struttura getPersistedStruttura(Struttura struttura) {
        return strutturaRepository.findById(struttura.getId()).orElseThrow();
    }

    protected void assertPersistedStrutturaToMatchAllProperties(Struttura expectedStruttura) {
        assertStrutturaAllPropertiesEquals(expectedStruttura, getPersistedStruttura(expectedStruttura));
    }

    protected void assertPersistedStrutturaToMatchUpdatableProperties(Struttura expectedStruttura) {
        assertStrutturaAllUpdatablePropertiesEquals(expectedStruttura, getPersistedStruttura(expectedStruttura));
    }
}
